/**
  ******************************************************************************
  * @file    YKNCT.h
  * @author  
  * @version V1.5.0
  * @date    
  * @brief   八代ロボコン部ライブラリ統一ヘッダ
  ******************************************************************************
  */

/* ヘッダ再呼び出し防止のための定義 ------------------------------------------*/
#ifndef _YKNCT_H_
#define _YKNCT_H_

/* 使用するライブラリ機能を定義すること */
//#define YKNCT_GPIO_ENABLED
//#define YKNCT_DMA_ENABLED
//#define YKNCT_TIM_ENABLED
//#define YKNCT_ADC_ENABLED
//#define YKNCT_UART_ENABLED

#define YKNCT_I2C_ENABLED
#define YKNCT_ENCODER_ENABLED
#define YKNCT_SBDBT_ENABLED
//#define YKNCT_MD_ENABLED
#define YKNCT_MECANUM_ENABLED
#define YKNCT_OMUNI_ENABLED
#define YKNCT_SERVO_ENABLED
#define YKNCT_KXM52_ENABLED

/* ファイル追加 --------------------------------------------------------------*/
#include "mbed.h"

/* 対応の使用ライブラリ機能を定義することで各ファイルが追加される */

//#ifdef YKNCT_GPIO_ENABLED
//#include "YKNCT_gpio.h"
//#endif /* YKNCT_GPIO_ENABLED */


//#ifdef YKNCT_DMA_ENABLED
//#include "YKNCT_dma.h"
//#endif /* YKNCT_DMA_ENABLED */


//#ifdef YKNCT_TIM_ENABLED
//#include "YKNCT_tim.h"
//#endif /* YKNCT_TIM_ENABLED */


//#ifdef YKNCT_ADC_ENABLED
//#include "YKNCT_adc.h"
//#endif /* YKNCT_ADC_ENABLED */


//#ifdef YKNCT_UART_ENABLED
//#include "YKNCT_uart.h"
//#endif /* YKNCT_UART_ENABLED */


#ifdef YKNCT_I2C_ENABLED
#include "YKNCT_I2C.h"
#endif /* YKNCT_I2C_ENABLED */

#ifdef YKNCT_SBDBT_ENABLED
#include "SBDBT.h"
#endif /* YKNCT_CONTROLLER_ENABLED */

#ifdef YKNCT_MD_ENABLED
#include "MD.h"
#endif /* YKNCT_MD_ENABLED */

//#ifdef YKNCT_OMUNI_ENABLED
//#include "omuni.h"
//#endif /* YKNCT_OMNI_ENABLED */
//
//#ifdef YKNCT_MECANUM_ENABLED
//#include "mecanum.h"
//#endif /* YKNCT_MECANUM_ENABLED */
//
//#ifdef YKNCT_SERVO_ENABLED
//#include "servo.h"
//#endif /* YKNCT_SERVO_ENABLED */

#ifdef YKNCT_ENCODER_ENABLED
#include "encoder.h"
#endif /* YKNCT_ENCODER_ENABLED */

//#ifdef YKNCT_KXM52_ENABLED
//#include "KXM52.h"
//#endif /* YKNCT_KXM52_ENABLED */



/* 型定義 --------------------------------------------------------------------*/

/* 定数定義 ------------------------------------------------------------------*/

/* マクロ定義 ----------------------------------------------------------------*/

/* 変数宣言 ------------------------------------------------------------------*/

/* 関数宣言 ------------------------------------------------------------------*/

#endif /* _YKNCT_H_ */

/******************************** END OF FILE *********************************/
